"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.camelizeKeys = exports.camelize = void 0;
const isDate_1 = require("./isDate");
const isObject_1 = require("./isObject");
const camelize = (str) => {
    return str.replace(/^([A-Z])|[\s-_/]+(\w)/g, (_match, p1, p2) => {
        if (p2) {
            return p2.toUpperCase();
        }
        return p1.toLowerCase();
    });
};
exports.camelize = camelize;
const camelizeKeys = (data) => {
    if (!isObject_1.default(data) || isDate_1.default(data)) {
        return data;
    }
    if (Array.isArray(data)) {
        return data.map((datumn) => {
            return exports.camelizeKeys(datumn);
        });
    }
    return Object.entries(data).reduce((result, [k, v]) => {
        let value;
        if (!isObject_1.default(v) || isDate_1.default(v)) {
            value = v;
        }
        else {
            value = exports.camelizeKeys(v);
        }
        Object.assign(result, {
            [exports.camelize(k)]: value,
        });
        return result;
    }, {});
};
exports.camelizeKeys = camelizeKeys;
