export declare type TMode = 'flatten' | 'mapping';
export declare type TObject = Record<string, string | number | boolean | null | object>;
declare type TBasic = string | number | boolean;
interface IResourceObjectProps {
    id: string;
    type: string;
}
interface IRelationshipsProps {
    [key: string]: {
        data: IResourceObjectProps | IResourceObjectProps[] | null;
    } | undefined;
}
interface IAttributesProps {
    [key: string]: TBasic | TBasic[] | null | TObject | TObject[] | undefined;
}
export interface IExtractDataReturnProps {
    id: string;
    relationships: {
        [key: string]: IResourceObjectProps | IResourceObjectProps[];
    };
    [key: string]: string | TObject;
}
declare type TExtractDataReturn<T extends TMode> = T extends 'mapping' ? IExtractDataReturnProps : TObject;
export interface IDataProps extends IResourceObjectProps {
    attributes: IAttributesProps;
    relationships?: IRelationshipsProps;
}
export declare function extractData<T extends TMode = 'flatten'>(data: IDataProps, mode?: T): TExtractDataReturn<T>;
export declare const extractIncluded: (data?: IDataProps[], mode?: TMode) => Record<string, Record<string, TObject>>;
export {};
